<?php
/*
 * Created on Aug 6, 2007
 *
 * To change the template for this generated file go to
 * Window - Preferences - PHPeclipse - PHP - Code Templates
 */
 
require_once('midgard_admin_sitewizard_creator.php');
require_once('midgard_admin_sitewizard_exception.php');

class midgard_admin_sitewizard_creator_structure extends midgard_admin_sitewizard_creator
{
    private $host = null;

    private $host_creator = null;

    private $root_topic = null;

    private $root_page = null;

    private $creation_root_topic = null;

    private $creation_root_group = null;

    private $sitegroup = null;
 	
    private $config = null;
 	
    private $structure = null;

    private $created_groups = array();

    public function __construct($host_creator = null)
    {
        // Always a good idea to run parent constructor
        parent::__construct($host_creator);
    }

    public function __destruct()
    {
        parent::__destruct();
    }

    protected function cleanup()
    {
        $this->verbose('Cleaning up!');

    }
 
    public function initialize($host_guid)
    {
        $this->verbose('Initializing structure creation');

        if ($this->host_creator == null)
 	    {
            if (!$this->host = new midgard_host($host_guid))
	        {
		        throw new midgard_admin_sitewizard_exception("Sitewizard couldn't initialize host 
		            object. Reason: " . mgd_errstr());

	            return false;
            }
            else
            {
	            $this->verbose("Getting sitegroup of host GUID: " . $this->host->guid);
                $sitegroup_id = $this->host->sitegroup;
/*
		$this->sitegroup = new midgard_sitegroup();
		$this->sitegroup->get_by_id($sitegroup_id);
*/
                $this->sitegroup = mgd_get_sitegroup($sitegroup_id);

	            $this->verbose("Getting root page of host GUID: " . $this->host->guid);
		        $this->root_page = new midgard_page();
		        $this->root_page->get_by_id($this->host->root);

                $root_topic_guid = $this->root_page->parameter('midgard', 'midcom_root_topic_guid');

		        if (empty($root_topic_guid))
		        {
                    throw new midgard_admin_sitewizard_exception("Failed to get valid root topic 
                        guid from root page parameter GUID: " . $root_topic_guid . " Reason: " . mgd_errstr());

		            return false;
		        }
		        else
		        {
		            $this->verbose("Getting root topic of page GUID: " . $this->root_page->guid);
		            $this->root_topic = new midgard_topic($root_topic_guid);
                }

	            return true;
	        }
        }
    }
 	
    public function read_config($path)
    {
        $this->config = $this->get_structure_config_filesystem($path);	
    }
    
    public function alter_config($key_chain, $value)
    {
        if ($this->config != null)
        {
            $arr_ref =& $this->config;
           
            for($i = 0; $i < count($key_chain); $i++)
            {
                $arr_ref =& $arr_ref[$key_chain[$i]];
            }
            
            $arr_ref = $value;  
            
            print_r($this->config);
        }
        else
        {
            throw new midgard_admin_sitewizard_exception('There is no configuration array.');
        }
    }
 	
   /**
    * There is no next link in the chain 
    * so this just runs execute()
    */
    public function next_link()
    {
        $this->execute();
    }
 	
    public function previous_link()
    {
        return $this->parent_link;
    }
    
    public function create_index_article($topic_id, $title = '')
    {
        $this->verbose("Creating index article for topic ID: " . $topic_id . " Title: " . $title);
    
        $article = new midgard_article();
        $article->topic = $topic_id;
        $article->title = $title;
        $article->name = 'index';
        
        if (!$article->create())
        {
            throw new midgard_admin_sitewizard_exception("Failed to create index article GUID: " 
	            . $article->guid . " Reason: " . mgd_errstr());             
        }
        else
        {
            return true;
        }
        
        return false;      
    }

    public function set_creation_root_group($group_guid)
    {
        if (!$this->creation_root_group = new midgard_group($group_guid))
	    {
            throw new midgard_admin_sitewizard_exception("Failed to set root group for structure creation GUID: " 
	        . $group_guid . " Reason: " . mgd_errstr()); 
	
	        return true;
	    }
	    else
	    {
            $this->verbose("Setting group for structure creation GUID: " . $group_guid);

	        return true;
	    }
    }

    public function set_creation_root_topic($topic_guid)
    {
        if (!$this->creation_root_topic = new midgard_topic($topic_guid))
	    {
            throw new midgard_admin_sitewizard_exception("Failed to set root topic for structure creation GUID: " 
	        . $topic_guid . " Reason: " . mgd_errstr()); 
	
	        return true;
	    }
	    else
	    {
            $this->verbose("Setting topic for structure creation GUID: " . $topic_guid);

	        return true;
	    }
    }

    public function create_creation_root_group($owner_guid, $group_name)
    {
        $this->verbose("Creating a root group for group structure creation under group GUID: " .  $owner_guid);

        $owner_group = new midgard_group($owner_guid);

	    $qb = new midgard_query_builder('midgard_group');
	    $qb->add_constraint('sitegroup', '=', $this->sitegroup->id);
	    $qb->add_constraint('owner', '=', $owner_group->id);
	    $qb->add_constraint('name', '=', $group_name);

	    $groups = $qb->execute();

	    if (count($groups) > 0)
	    {
            $this->verbose("Group \"" . $group_name . "\" GUID: " . $groups[0]->guid 
	        . " already exists. Setting as root group for structure creation.");

	        $this->creation_root_group = $groups[0];

	        return true;
	    }
	    else
	    {
	        $this->creation_root_group = new midgard_group();
  	        $this->creation_root_group->owner = $owner_group->id;
	        $this->creation_root_group->sitegroup = $this->sitegroup->id;
	        $this->creation_root_group->name = $group_name;

            if (!$this->creation_root_group->create())
	        {
                throw new midgard_admin_sitewizard_exception("Failed to create root group for group 
                    structure creation under group GUID: " . $this->creation_root_group->guid);
	        }
	        else
	        {
                return true;
	        }
        }
    }

    public function create_creation_root_topic($topic_guid, $topic_name = '', $topic_title = '', 
        $component = '', $parameters = array(), $style = '', $create_index = false)
    {
        $this->verbose('Creating a root topic for structure creation');

        $topic = new midgard_topic($topic_guid);
        
        $mc = new midgard_collector('midgard_topic', 'up', $topic->id);
        $mc->add_constraint('name', '=', $topic_name);
        $mc->set_key_property('id');
        $mc->execute();
        $keys = $mc->list_keys();
        
        if (count($keys) > 0)
        {
            throw new midgard_admin_sitewizard_exception("Can't create root topic! Reason: name already exists.");
        }
        else
        {
	        $this->creation_root_topic = new midgard_topic();
	        $this->creation_root_topic->extra = $topic_title;
	        $this->creation_root_topic->name = $topic_name;
	        $this->creation_root_topic->sitegroup = $this->sitegroup->id;
	        $this->creation_root_topic->component = $component;
	        $this->creation_root_topic->up = $topic->id;
	        
	        if (!empty($style))
	        {
	            $this->verbose("Setting style for topic" . $topic_name . ": (" . $style . ")");
	            $this->creation_root_topic->style = $style;
	        }

            if (!$this->creation_root_topic->create())
	        {
                throw new midgard_admin_sitewizard_exception("Failed to create root topic for structure creation GUID: " 
	                . $this->creation_root_topic->guid . " Reason: " . mdg_errstr());
	        }
	        else
	        {
	            // Setting style parameter
	            if (!empty($style))
	            {
	                $this->creation_root_topic->parameter('midcom', 'style', $style);
	            }
	            
                $this->verbose("Created root topic for structure creation GUID: " . $this->creation_root_topic->guid);
	    
	            // Setting additional parameters
                foreach ($parameters as $domain => $parameter)
	            {
                    foreach ($parameter as $name => $value)
		            {
                        $this->creation_root_topic->parameter($domain, $name, $value);
		            }
	            }
	            
	            if ($create_index == true)
	            {
	                $this->create_index_article($this->creation_root_topic->id, $topic_title);
	            }
	        }
	    }
    }

    private function replace($string)
    {
        $result = str_replace('__HOSTNAME__', $this->host->name, $string);
        $result = str_replace('__HOSTTITLE__', $this->root_page->title, $result);

        return $result;
    }

    private function create_topic_structure_recursive($nodes, $parent_node)
    {
	    foreach ($nodes as $node)
	    {
            $this->verbose("Creating topic \"" . $this->replace($node['title']) . "\" under parent topic GUID: " 
	        . $parent_node->guid);

	        $topic = new midgard_topic();
	        $topic->up = $parent_node->id;
            $topic->name = $this->replace($node['name']);
	        $topic->extra = $this->replace($node['title']);
	        $topic->sitegroup = $this->sitegroup->id;
	        $topic->component = $node['component'];
	        
	        if (isset($node['style']) && !empty($node['style']))
	        {
	            $this->verbose("Setting style for topic " . $node['name'] . ": (" . $node['style'] . ")");
	            $topic->style = $node['style'];
	        }

	        if (!$topic->create())
	        {
                throw new midagard_admin_sitewizard_exception("Failed to create topic \"" 
                    . $topic->extra . "\" under parent GUID: " . $parent_node->guid);
	        }
	        else
	        {
	            // Setting style parameter
	            if (isset($node['style']) && !empty($node['style']))
	            {
	                $topic->parameter('midcom', 'style', $node['style']);
	            }
	            
	            // Setting additional parameters
	            if (isset($node['parameters']) && count($node['parameters']) > 0)
                {
                    $this->verbose("Starting to set additional parameters for topic GUID: " . $topic->guid);
                    
                    $this->set_parameters($node, $topic);
		        }

		        // Setting midcom acl privileges
                if (isset($node['acl']) && count($node['acl']) > 0)
	            {
                    $this->verbose("Starting to set midcom acl privileges for topic GUID: " . $topic->guid);

                    $this->set_privileges($node, $this->creation_root_topic);
	            }
	            
	            if (isset($node['create_index']) && $node['create_index'] == true)
	            {
	                $this->create_index_article($topic->id, $this->replace($node['title']));
	            }
	        }

	        if (isset($node['nodes']) && count($node['nodes']) > 0)
	        {
                $this->create_topic_structure_recursive($node['nodes']);
	        }
	    }
    }

    private function set_parameters($config_node, $object)
    {
        foreach ($config_node['parameters'] as $domain => $parameter)
	    {
	        foreach ($parameter as $name => $value)
	        {
                $this->verbose("Setting parameter (" . $domain . "," . $name . "," . $value .") for object GUID: " 
                    . $object->guid);
	        
		        $object->parameter($domain, $name, $value);
	        }
        }
	    return true;
    }

    private function set_privileges($config_node, $object)
    {
        foreach($config_node['acl'] as $group_name => $privilege)
	    {
	        foreach($privilege as $name => $value)
	        {
	            if (array_key_exists($group_name, $this->created_groups))
		        {
                    $acl = new midcom_core_privilege_db(); 
		            $acl->objectguid = $object->guid;
		            $acl->name = $name;
		            $acl->sitegroup = $this->sitegroup->id;
		            $acl->assignee = "group:" . $this->created_groups[$group_name]->guid;
		            $acl->value = $value;
		
		            if (!$acl->create())
		            {
                        throw new midgard_admin_sitewizard_exception();
		            }
		            else
		            {
                        $this->verbose("ACL (" . $acl->name . "," . $acl->assignee . "," 
                            . $acl->value . " set for object GUID: " . $object->guid);
			
			            return true;
		            }
		        }
	        } 
        }
    }

    public function create_topic_structure()
    {
        $this->verbose("Starting to create topic structure under topic GUID: " . $this->creation_root_topic->guid);

	    foreach ($this->config as $structure)
	    {
	        $this->structure = $structure;
	    }

        // Creating root topic from configuration if it hasn't been set already
        if ($this->creation_root_topic == null)
	    {
            $this->verbose('Creating root topic from configuration');

	        $this->creation_root_topic = midgard_topic();
	        $this->creation_root_topic->up = 0;
	        $this->creation_root_topic->sitegroup = $this->sitegroup->id;
	        $this->creation_root_topic->extra = $this->structure['root']['title']; 
	        $this->creation_root_topic->name = $this->structure['root']['name'];
	        
	        if (isset($node['root']['style']) && !empty($node['root']['style']))
	        {
	            $this->verbose("Setting style for topic " . $this->structure['root']['name'] 
	                . "(" . $node['root']['style'] . ")");
	            $this->creation_root_topic->style = $node['root']['style'];
	        }

	        if (!$this->creation_root_topic->create())
	        {
                throw new midgard_admin_sitewizard_exception("Failed to create root topic \"" 
                    . $this->structure['root']['name'] . "\" for structure creation");

		        return false;    
	        }
	        else
	        {
	            // Setting style parameter
	            if (isset($node['root']['style']) && !empty($node['root']['style']))
	            {
	                 $this->creation_root_topic->parameter('midcom', 'style', $node['root']['style']);
	            }
	        
	            // Setting additional parameters
		        if (isset($this->structure['root']['parameters']) && count($this->structure['root']['parameters']) > 0)
		        {
		            $this->set_parameters($this->structure['root'], $this->creation_root_topic);
                }

                // Setting midcom acl privileges
                if (isset($this->structure['root']['acl']) && count($this->structure['root']['acl']) > 0)
	            {
                    $this->set_privileges($this->structure['root'], $this->creation_root_topic);
		        }
		        
		        if (isset($this->structure['root']['create_index']) && $this->structure['root']['create_index'] == true)
		        {
	                $this->create_index_article($this->creation_root_topic->id, $this->replace($node['root']['title']));
		        }
	        }
        }

        // Making sure the topic is empty before creating a structure
	   $qb = new midgard_query_builder('midgard_topic');
	   $qb->add_constraint('up', '=', $this->creation_root_topic->id);
	   $qb->add_constraint('sitegroup', '=', $this->sitegroup->id);
       $topics = $qb->execute();
	
	   if (count($topics) != 0)
	   {
	       throw new midgard_admin_sitewizard_exception('Creation root topic is not empty!');
	   }
	   else
	   {
           try
	       {
	           $this->create_topic_structure_recursive($this->structure['root']['nodes'], $this->creation_root_topic);
	       }
	       catch (midgard_admin_sitewizard_exception $e)
	       {
                $e->error();

                throw new midgard_admin_sitewizard_exception("Failed to create topic structure under topic GUID: " 
		            . $this->creation_root_topic->guid . "Reason: " . mgd_errstr());
	    
	        }
	    }
    }

    public function create_group_structure()
    {
        if ($this->creation_root_group != null)
	    {   
            $group_owner_id = $this->creation_root_group->id;
	    }
	    else
	    {
	         $group_owner_id = $this->sitegroup->admingroup;
	    }

        $this->verbose("Starting to create groups under group ID: " . $group_owner_id);

        $qb = new midgard_query_builder('midgard_group');
	    $qb->add_constraint('sitegroup', '=', $this->sitegroup->id);
	    $qb->add_constraint('owner', '=', $group_owner_id);
	    $groups = $qb->execute();

	    if (count($groups) != 0)
	    {
            // Ok, let's first check if a group already exists          
	        foreach ($this->config as $structure)
	        {
                foreach ($structure['groups'] as $candidate_group_name)
		        {
		    
		            $this->verbose("Checking if group \"" . $candidate_group_name . "\" already exists");

                    $group_match = 0;

		            foreach ($groups as $group)
		            {
                        if ($group->name == $candidate_group_name)
			            {
                            $this->created_groups[$group->name] = $group;
			                $group_match++; 
			            }
		            }

		            if ($group_match > 0)
		            {
		                $this->verbose("Group \"" . $candidate_group_name . "\" already exists! No need to create");   
		            }
		            elseif (count($groups) > 0)
		            {
                        $this->verbose("Group \"" . $candidate_group_name . "\" does not exist! Creating now");
		   
                        $new_group = new midgard_group();
			            $new_group->owner = $group_owner_id;
			            $new_group->sitegroup = $this->sitegroup->id;
			            $new_group->name = $candidate_group_name;
                        
			            if (!$new_group->create())
			            {
                            throw new midgard_admin_sitewizard("Failed to create group \"" . $candidate_group_name 
			                    . "\" GUID: " . $new_group->guid . " Reason: " . mgd_errstr());
			            }
			            else
			            {
			                $this->created_groups[$new_group->name] = $new_group; 
			                return true;
			            }
                    }
		        }
	        }
	    }
	    else
	    {
	        // There are no groups so we can just create the groups from config file         
	        foreach ($this->config as $structure)
	        {	    
                foreach ($structure['groups'] as $candidate_group_name)
		        {
                    $this->verbose("Group \"" . $candidate_group_name . "\" does not exist! Creating now");
		    
                    $new_group = new midgard_group();
		            $new_group->name = $candidate_group_name;
                    $new_group->sitegroup = $this->sitegroup->id;
		            $new_group->owner = $group_owner_id;

                    if (!$new_group->create())
		            {
                        throw new midgard_admin_sitewizard("Failed to create group \"" . $candidate_group_name 
			                . "\" GUID: " . $new_group->guid . " Reason: " . meg_errstr());
		            }
		            else
	                {
	                     return true;
		            }
		        }
	        }            
        }
    }

    public function execute()
    {
        $this->verbose('Starting execution chain (midgard_admin_sitewizard_creator_structure)');

        if ($this->parent_link != null)
        {
	        $this->verbose('Executing parent');

	        try
	        {
                $this->parent_link->execute();		
	        }
	        catch (midgard_admin_sitewizard_exception $e)
	        {
                $e->error();

                throw new midgard_admin_sitewizard_exception("Failed to execute parent creator");
	        }
        }

        try 
	    {
	        $this->create_group_structure();
	        $this->create_topic_structure();

	        $this->verbose("Sitewizard created website structure successfully. Now cleaning up...");

	        $this->cleanup();
	        
	        return $this->creation_root_topic->guid;
        }
	    catch(midgard_admin_sitewizard_exception $e)
	    {
	        $e->error();      
            $this->cleanup();
  
	        throw new midgard_admin_sitewizard_exception("Failed to create structure");
	
	        return false;
	    }
    }
}
 
?>
